<?php
//creo il post type per l'area riservata
add_action('init', 'crea_contenuti');
function crea_contenuti() {

    $labels = array(
        'name'               => __('Area Riservata'),
        'singular_name'      => __('Contenuto'),
        'add_new'            => __('Aggiungi Contenuto'),
        'add_new_item'       => __('Nuovo Contenuto'),
        'edit_item'          => __('Modifica Contenuto'),
        'new_item'           => __('Nuovo Contenuto'),
        'all_items'          => __('Elenco Contenuti'),
        'view_item'          => __('Visualizza Contenuti'),
        'search_items'       => __('Cerca Contenuto'),
        'not_found'          => __('Contenuto non trovato'),
        'not_found_in_trash' => __('Contenuto non trovato nel cestino'),
    );

    $args = array(
        'labels'             => $labels,
        'public'             => true,
        'rewrite'            => array('slug' => 'contenuti'),
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => 5,
        'supports'           => array(
                                'title',
                                'editor',
                                'thumbnail'
                                ),

    );

   register_post_type('area-riservata', $args);
}

//rendo il post type privato di default
function force_type_private($post)
{
    if ($post['post_type'] == 'area-riservata') {
    
        if ($post['post_status'] != 'trash') $post['post_status'] = 'private';
        
    }
    return $post;
}
add_filter('wp_insert_post_data', 'force_type_private');




//rendo il post privato visibile al ruolo sottoscrittore
$subRole = get_role( 'subscriber' );
$subRole->add_cap( 'read_private_posts' );


// Rimuovo la parola Privato dal titolo
function clean_title($titolo) {
	$titolo = attribute_escape($titolo);
	$cerca = array(
		'#Privato:#'
	);
	$sostituisci = array(
		'-' // Sostituiamo la voce "Privato" con -
	);
	$titolo = preg_replace($cerca, $sostituisci, $titolo);
	return $titolo;
}
add_filter('the_title', 'clean_title');



//nascondo la barra di wordpress tranne che all' admin
if (!current_user_can('manage_options')) {
	add_filter('show_admin_bar', '__return_false');
}
if (!current_user_can('edit_posts')) {
	add_filter('show_admin_bar', '__return_false');
}



?>
<?php /*** Funzione Background Attiva ***/

	add_custom_background();

?>
<?php /*** Funzione Menu Attiva ***/

	if (function_exists('add_theme_support')) {
		add_theme_support('menus');
	}

?>
<?php /*** Formattazione Widget ***/

	if ( function_exists('register_sidebar') )
	register_sidebar(array(
	'before_widget' => '<aside id="%1$s" class="widget %2$s">',	
	'after_widget' => '</aside>',
	'before_title' => '<h3>',
	'after_title' => '</h3>',
	));
	
?>
<?php /*** Funzione Thumbnail Attiva ***/

add_theme_support('post-thumbnails');

if ( function_exists('add_theme_support') ) {
	add_theme_support('post-thumbnails');
}
if ( function_exists( 'add_image_size' ) ) { 
	add_image_size( 'index-thumb', 600, 999 ); 	//(cropped) 
	add_image_size( 'slider-img-front', 330, 280, true ); //(cropped)
	add_image_size( 'slider-img-back', 280, 230, true ); //(cropped)		
}
/*
the_post_thumbnail('thumbnail');       // Thumbnail (default 150px x 150px max)
the_post_thumbnail('medium');          // Medium resolution (default 300px x 300px max)
the_post_thumbnail('large');           // Large resolution (default 640px x 640px max)
*/

?>
<?php /*** Reimpostimao la lunghezza dell'Excerpt ***/

class Excerpt {

  // Lunghezza di Default impostatat da Wordpress
  public static $length = 55;

  // Puoi richiamare: my_excerpt('short');
  public static $types = array(
      'short' => 25,
      'regular' => 55,
      'long' => 100
    );

  public static function length($new_length = 55) {
    Excerpt::$length = $new_length;

    add_filter('excerpt_length', 'Excerpt::new_length');

    Excerpt::output();
  }

  // Comunico a Wordpress la nuova lunghezza
  public static function new_length() {
    if( isset(Excerpt::$types[Excerpt::$length]) )
      return Excerpt::$types[Excerpt::$length];
    else
      return Excerpt::$length;
  }

  // Mostriamo l'excerpt
  public static function output() {
    the_excerpt();
  }

}

// Alias alla classe
function my_excerpt($length = 55) {
  Excerpt::length($length);
}

// Cambiamo il more dell'excerpt
function new_excerpt_more($more) {
	global $post;
	return '<a href="'. get_permalink($post->ID) . '"> Leggi...</a>';
}
add_filter('excerpt_more', 'new_excerpt_more');

?>
<?php /*** Paginazione con numeri ***/

function buby_pagination($pages = '', $range = 9)
{  
     $showitems = ($range * 2)+1;  

     global $paged;
     if(empty($paged)) $paged = 1;

     if($pages == '')
     {
         global $wp_query;
         $pages = $wp_query->max_num_pages;
         if(!$pages)
         {
             $pages = 1;
         }
     }   

     if(1 != $pages)
     {
         echo "<div class='pagination'>";
         if($paged > 2 && $paged > $range+1 && $showitems < $pages) echo "<a href='".get_pagenum_link(1)."'>&laquo;</a>";
         if($paged > 1 && $showitems < $pages) echo "<a href='".get_pagenum_link($paged - 1)."'>&lsaquo;</a>";

         for ($i=1; $i <= $pages; $i++)
         {
             if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
             {
                 echo ($paged == $i)? "<span class='current'>".$i."</span>":"<a href='".get_pagenum_link($i)."' class='inactive' >".$i."</a>";
             }
         }

         if ($paged < $pages && $showitems < $pages) echo "<a href='".get_pagenum_link($paged + 1)."'>&rsaquo;</a>";  
         if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) echo "<a href='".get_pagenum_link($pages)."'>&raquo;</a>";
         echo "</div>\n";
     }
}

?>
<?php /*** Hr button ***/

function enable_more_buttons($buttons) {
  $buttons[] = 'hr';
  return $buttons;
}
add_filter("mce_buttons", "enable_more_buttons");

?>
<?php  /*** Predisposizione per creare metabox nell'backend ***/

add_action( 'add_meta_boxes', 'cd_meta_box_add' );

function cd_meta_box_add(){
	add_meta_box( 'my-meta-box-id', 'Opzioni articolo', 'cd_meta_box_cb', 'post', 'normal', 'low' );
}
function cd_meta_box_cb( $post ){

	$values = get_post_custom( $post->ID );
	$text = isset( $values['my_meta_box_input'] ) ? esc_attr( $values['my_meta_box_input'][0] ) : '';
	$selected = isset( $values['my_meta_box_select'] ) ? esc_attr( $values['my_meta_box_select'][0] ) : '';
	$check = isset( $values['my_meta_box_check'] ) ? esc_attr( $values['my_meta_box_check'][0] ) : '';
	wp_nonce_field( 'my_meta_box_nonce', 'meta_box_nonce' );
	
	?>

        <p>
            <label style="padding:5px;" for="my_meta_box_input">Esempio di Metabox Input</label></br>
            <input type="text" name="my_meta_box_input" id="my_meta_box_input" value="<?php echo $text; ?>" style="width:82%"/><br/>
            <small  style="padding:5px;">Per richimare il campo nel tema utilizza: <code>echo get_post_meta($post->ID, 'my_meta_box_input', TRUE);</code></small>
        </p>
        
        <p>
            <label style="padding:5px;" for="my_meta_box_select">Esempio di Metabox Select.</label></br>
            <select name="my_meta_box_select" id="my_meta_box_select">
                <option value="big" <?php selected( $selected, 'Big' ); ?>>Image Big</option>
                <option value="left" <?php selected( $selected, 'Left' ); ?>>Image Left</option>
                <option value="right" <?php selected( $selected, 'Right' ); ?>>Image Right</option>
            </select>
            <small style="padding:5px;">Per richimare il campo nel tema utilizza: <code>echo get_post_meta($post->ID, 'my_meta_box_select', TRUE);</code> </small>
        </p>
        
        <p> <label for="my_meta_box_check">Esempio di Metabox Check.</label></br>
            <input type="checkbox" name="my_meta_box_check" id="my_meta_box_check" <?php checked( $check, 'on' ); ?> />
            <small style="padding:5px;">Per richimare il campo nel tema: <code>echo get_post_meta($post->ID, 'my_meta_box_check', TRUE);</code> </small>
        </p> 

    
	<?php	
}

add_action( 'save_post', 'cd_meta_box_save' );
function cd_meta_box_save( $post_id ){

	// Bail if we're doing an auto save
	if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
	
	// if our nonce isn't there, or we can't verify it, bail
	if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'my_meta_box_nonce' ) ) return;
	
	// if our current user can't edit this post, bail
	if( !current_user_can( 'edit_post' ) ) return;
	
	// now we can actually save the data
	$allowed = array( 
		'a' => array( // on allow a tags
			'href' => array() // and those anchords can only have href attribute
		)
	);

	// Probably a good idea to make sure your data is set
	if( isset( $_POST['my_meta_box_input'] ) )
		update_post_meta( $post_id, 'my_meta_box_input', wp_kses( $_POST['my_meta_box_input'], $allowed ) );

	if( isset( $_POST['my_meta_box_select'] ) )
		update_post_meta( $post_id, 'my_meta_box_select', esc_attr( $_POST['my_meta_box_select'] ) );

	// This is purely my personal preference for saving checkboxes
	$chk = ( isset( $_POST['my_meta_box_check'] ) && $_POST['my_meta_box_check'] ) ? 'on' : 'off';
	update_post_meta( $post_id, 'my_meta_box_check', $chk );

}

?>
<?php /*** Rimuovo i meatabox che non  mi servono dall'Backend ***/

add_action('do_meta_boxes', 'my_setting_meta_box');

function my_setting_meta_box(){

	 /* Removes meta boxes from Posts */
	  remove_meta_box('postcustom','post','normal');
	  remove_meta_box('trackbacksdiv','post','normal');
	  /*remove_meta_box('commentstatusdiv','post','normal');*/
	  /*remove_meta_box('commentsdiv','post','normal');*/
	  remove_meta_box('postexcerpt','post','normal');

 	 /* Removes meta boxes from pages */	 
	 
	 
}

?>
<?php /*** Opzioni Tema (SEO) nel Backend ***/

add_action('admin_menu', 'buby_theme_page');
function buby_theme_page ()
{
	if ( count($_POST) > 0 && isset($_POST['buby_settings']) )
	{
		$options = array ('keywords','description','analytics');
		
		foreach ( $options as $opt )
		{
			delete_option ( 'buby_'.$opt, $_POST[$opt] );
			add_option ( 'buby_'.$opt, $_POST[$opt] );	
		}			
		 
	}
	add_menu_page(__('Theme Options'), __('Theme Options'), 'edit_themes', basename(__FILE__), 'buby_settings');
	add_submenu_page(__('Theme Options'), __('v'), 'edit_themes', basename(__FILE__), 'buby_settings');
}
function buby_settings()
{?>
<div class="wrap">
<h2>Theme Options</h2>
	
<form method="post" action="">
 
    <fieldset style="border:1px solid #ddd; padding-bottom:20px; margin-top:20px;">
	<legend style="margin-left:5px; padding:0 5px; color:#2481C6;text-transform:uppercase;"><strong>SEO</strong></legend>
		<table class="form-table">
        <tr>
			<th><label for="keywords">Meta Keywords</label></th>
			<td>
				<textarea name="keywords" id="keywords" rows="7" cols="70" style="font-size:11px;"><?php echo get_option('buby_keywords'); ?></textarea>
                <em>Keywords comma separated</em>
			</td>
		</tr>
        <tr>
			<th><label for="description">Meta Description</label></th>
			<td>
				<textarea name="description" id="description" rows="7" cols="70" style="font-size:11px;"><?php echo get_option('buby_description'); ?></textarea>
			</td>
		</tr>
		<tr>
			<th><label for="ads">Google Analytics code:</label></th>
			<td>
				<textarea name="analytics" id="analytics" rows="7" cols="70" style="font-size:11px;"><?php echo stripslashes(get_option('buby_analytics')); ?></textarea>
			</td>
		</tr>
        
	</table>
	</fieldset>
    
    <p class="submit">
		<input type="submit" name="Submit" class="button-primary" value="Save Changes" />
		<input type="hidden" name="buby_settings" value="save" style="display:none;" />
		</p>

</form>
</div>
<?php }?>